=== debian/changelog ===
pioneer (0.0~alpha29+git-1) unstable; urgency=low

  * Update packaging for current state (alpha29).

 -- Roland Mas <lolando@debian.org>  Mon, 17 Dec 2012 16:08:25 +0100

pioneer (0.0~alpha11-1) unstable; urgency=low

  * Nice fresh release.

 -- Darren Salt <linux@youmustbejoking.demon.co.uk>  Tue, 07 Jun 2011 00:28:40 +0100

pioneer (0.0~alpha10-1) unstable; urgency=low

  * Nice fresh release.

 -- Darren Salt <linux@youmustbejoking.demon.co.uk>  Fri, 13 May 2011 02:33:21 +0100

pioneer (0.0~alpha9+git-1) unstable; urgency=low

  * Initial packaging. (Closes: #000000)

 -- Darren Salt <linux@youmustbejoking.demon.co.uk>  Sat, 02 Apr 2011 23:44:58 +0100
