=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PIONEER_DATA_DIR = /usr/share/games/pioneer/data

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
			     -DPIONEER_DATA_DIR="$(PIONEER_DATA_DIR)"
